package org.jeecg.modules.sensor.controller;

import java.util.Arrays;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.sensor.entity.BuStatus;
import org.jeecg.modules.sensor.service.IBuStatusService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 状态表
 * @Author: jeecg-boot
 * @Date:   2024-05-07
 * @Version: V1.0
 */
@Api(tags="状态表")
@RestController
@RequestMapping("/acode/buStatus")
@Slf4j
public class BuStatusController extends JeecgController<BuStatus, IBuStatusService> {
	@Autowired
	private IBuStatusService buStatusService;
	
	/**
	 * 分页列表查询
	 *
	 * @param buStatus
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "状态表-分页列表查询")
	@ApiOperation(value="状态表-分页列表查询", notes="状态表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuStatus>> queryPageList(BuStatus buStatus,
												 @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												 @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												 HttpServletRequest req) {
		QueryWrapper<BuStatus> queryWrapper = QueryGenerator.initQueryWrapper(buStatus, req.getParameterMap());
		Page<BuStatus> page = new Page<BuStatus>(pageNo, pageSize);
		IPage<BuStatus> pageList = buStatusService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param buStatus
	 * @return
	 */
	@AutoLog(value = "状态表-添加")
	@ApiOperation(value="状态表-添加", notes="状态表-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_status:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuStatus buStatus) {
		buStatusService.save(buStatus);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buStatus
	 * @return
	 */
	@AutoLog(value = "状态表-编辑")
	@ApiOperation(value="状态表-编辑", notes="状态表-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_status:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuStatus buStatus) {
		buStatusService.updateById(buStatus);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "状态表-通过id删除")
	@ApiOperation(value="状态表-通过id删除", notes="状态表-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_status:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buStatusService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "状态表-批量删除")
	@ApiOperation(value="状态表-批量删除", notes="状态表-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_status:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buStatusService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "状态表-通过id查询")
	@ApiOperation(value="状态表-通过id查询", notes="状态表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuStatus> queryById(@RequestParam(name="id",required=true) String id) {
		BuStatus buStatus = buStatusService.getById(id);
		if(buStatus==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buStatus);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buStatus
    */
    //@RequiresPermissions("org.jeecg.modules.demo:bu_status:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuStatus buStatus) {
        return super.exportXls(request, buStatus, BuStatus.class, "状态表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_status:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuStatus.class);
    }

}
